package com.ashokit.ticketbooking.dao;

import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Repository;

import com.ashokit.ticketbooking.model.Ticket;

/*
 * 
 * DAO ==> Data Access Object
 * 
 * DAO is going to create data base wrapper object where we can work with database 
 *   during CRUD Operations
 *   
 *    C ==> CREATE ==> INSERT
 *    R ==> READ ==> SELECT
 *    U ==> MOIDFY ==> UPDATE
 *    D ==> DROP ==> DELETE
 *    
 *    
 *    JDBC WORLD ==> JDBC CONNECTION OBJECT
 *    
 *    HIBERNATE ==> SESSION FACTORY
 *    
 *    
 *    CRUD REPOSITORY IS CREATED ==> Entire boiler plate code will be removed and framework will take care
 */

@Repository
public interface TicketDao extends CrudRepository<Ticket, Integer> {
	
	
	/*
	 * CrudRepository==> TWo INput
	 * 
	 * 1) ClassName/TableName
	 * 2) Datatype of PK
	 * 
	 * 
	 * APIS given by CRUDRepository are
	 * 
	 * 1) save ==> Inserts the data / Updates the Data  ==>ticketDao.save(ticket)
	 * 2) findAll ==> Retrieves the Data from Table ==> ticketDao.findAll() ==> select * from tbl_ticket
	 * 3) findById ==> Retrieves the specific Record ==> ticketdao.findById() ==> select * from tbl_ticket where ticket_id=?
	 * 4) deleteById ==> Delete the record for a given Id ==> ticketDao.deleteById()
	 */
	
	
	
	//Abstract Method
	
	public Ticket findByPassengerName(String passengerName);
	//select * from tbl_ticket where passenger_name=passengerName

}
